package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.TSSDGroupDetailMapper;
import com.sa.ibiz.demo.demo.domain.TSSDGroupDetail;
import com.sa.ibiz.demo.demo.service.TSSDGroupDetailService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.TSSDGroupDetailSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.TSSDGroupService;
import com.sa.ibiz.demo.demo.service.TSSDItemService;

/**
 * 实体[TSSDGroupDetail] 服务对象接口实现
 */
@Service
public class TSSDGroupDetailServiceImpl extends ServiceImplBase<TSSDGroupDetailMapper, TSSDGroupDetail> implements TSSDGroupDetailService{

    @Autowired
    private TSSDGroupService tssdgroupService;
    @Autowired
    private TSSDItemService tssditemService;

    @Resource
    private TSSDGroupDetailMapper tssdgroupdetailMapper;


    @Override
    public boolean create(TSSDGroupDetail et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(TSSDGroupDetail et){
        this.beforeUpdate(et);
		this.tssdgroupdetailMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(TSSDGroupDetail et){
		return et.getTssdgroupdetailid();  
    }

    @Override
    public boolean getDraft(TSSDGroupDetail et)  {
    if((!StringUtils.isEmpty(et.getTssdgroupid())) && et.getTssdgroup() == null){
            try {
                et.setTssdgroup(tssdgroupService.getById(et.getTssdgroupid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getTssditemid())) && et.getTssditem() == null){
            try {
                et.setTssditem(tssditemService.getById(et.getTssditemid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<TSSDGroupDetail> listDefault(TSSDGroupDetailSearchFilter filter) {
		return tssdgroupdetailMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<TSSDGroupDetail> searchDefault(TSSDGroupDetailSearchFilter filter) {
		return tssdgroupdetailMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return tssdgroupdetailMapper.selectRow(sql);
    }

 }